// Copyright 2004,2005 Luke Campagnola <lcampagn@mines.edu>, Colorado School of Mines
// 
// This file is part of VRManager.
// 
// VRManager is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
// 
// VRManager is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with VRManager; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "Comm.h"
#include "debug.h"
      
Comm::Comm() {
  dependents.clear();
}

void Comm::informUpdate(int mesg) {
  if( this == NULL ) {
    return;
  }
  depChanged(mesg);
  for( slist<depData>::iterator i = dependents.begin(); i != NULL; i++ ) {
    i->comm->informUpdate(i->mesg);
  }
}

void Comm::addDependent( Comm *comm, int mesg ) {
  if( this == NULL ) {
    return;
  }
  // make sure this one isn't already in the list
  if( comm == NULL ) {
    msg(M_DEBUG, "ERROR: Not adding NULL dependency!\n");
    return;
  }
  for( slist<depData>::iterator i = dependents.begin(); i != NULL; i++ ) {
    if( comm == i->comm ) {
      return;
    }
  }
  depData tmp;
  tmp.comm = comm;
  tmp.mesg = mesg;
  dependents.push_front(tmp);
}

void Comm::depChanged(int mesg) {
  if( this == NULL ) {
    return;
  }

}

void Comm::clearDeps() {
  if( this == NULL ) {
    return;
  }
  dependents.clear();
}
