// Copyright 2004,2005 Luke Campagnola <lcampagn@mines.edu>, Colorado School of Mines
// 
// This file is part of VRManager.
// 
// VRManager is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
// 
// VRManager is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with VRManager; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "Tracker.h"
#include "debug.h"

  // Tracker methods
  
Tracker::Tracker() {
  isValid = false;
}

void Tracker::depChanged(int mesg) {
  isValid = false;
}

void Tracker::setOrigin(const Vector pos) {
  trackerOrigin = pos;
  informUpdate();
}

void Tracker::setLocation(Vector pos) {
  trackerLocation = pos;
  informUpdate();
}

void Tracker::setOrientationMatrix(Matrix m) {
  trackerOrientation = m;
  informUpdate();
}

void Tracker::setCoordSystem(Matrix newCS) {
  coordSystem = newCS;
  informUpdate();
}

Matrix* Tracker::getTransformMatrix() {
  if( ! isValid ) {
    coordSystem = translateMatrix(trackerOrigin) * translateMatrix(trackerLocation) * trackerOrientation;
    isValid = true;
  }
  return &coordSystem;
}
