// Copyright 2004,2005 Luke Campagnola <lcampagn@mines.edu>, Colorado School of Mines
// 
// This file is part of VRManager.
// 
// VRManager is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// (at your option) any later version.
// 
// VRManager is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with VRManager; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


#include "vrmObject.h"
#include "stdlib.h"
#include "string.h"

vrmObject::vrmObject() {
  vrmObjName = NULL;
  vrmObjPtr = NULL;
}


vrmObject::vrmObject(char* n, VRManager* v) {
  setVrmName(n);
  setVrm(v);
}

char* vrmObject::getVrmName() {
  return vrmObjName;
}

VRManager* vrmObject::getVrm() {
  return vrmObjPtr;
}

void vrmObject::setVrmName(char* n) {
  if( vrmObjName != NULL ) {
    delete[] vrmObjName;
  }
  vrmObjName = new char[strlen(n)+1];
  strcpy(vrmObjName, n);
}


void vrmObject::setVrm(VRManager* v) {
  vrmObjPtr = v;
}
